
/*****************************************************

Chip type               : ATmega328p
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
   Core    ad9850.   ad9850_Core_.

  , .

 ,   01.05.2021 .  
*****************************************************/


#include "encoder2.h"

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sfr_defs.h>
#include <stdio.h>
#include <math.h>
#include <util/delay.h>

#include "main.h"
#include "ldc.h"

#define StartConvAdc() ADCSRA |= (1<<ADSC)
#define StopConvAdc()   ADCSRA &=~(_BV(ADSC))  

#define Clock              PINC1

#define TCNT0_const 0
#define TCCR0_const 5

char    r;
char    l;
char    t;

int     chagi=10;

volatile unsigned int AdcBuf;
volatile unsigned int Adc_1;
volatile unsigned char mode;
volatile signed char bufEnc;  // 

unsigned long frequency, frequency_r, frequency_t, chagi_1, pch, z_1;       

	

char n, z, fast, y; 
char y=0; 
int shift;

char fast=0;

int _band, band_2;   

typedef unsigned char byte;

#define send_1 PORTC |=_BV(PC1)
#define send_0 PORTC &=~_BV(PC1)

#define F_MCLK  125000000                      // F_MCLK is 125 MHz

unsigned long freq, z_1;
char tmp;
unsigned long pch = 10700000;

/************      *******************/ 

unsigned long    freq_max[13]={2000000, 3800000, 7200000, 10150000, 14350000, 18168000, 21450000, 24990000, 30000000, 30000000, 30000000, 30000000}; 
unsigned long    freq_min[13]={1810000, 3500000, 7000000, 10100000, 14000000, 18068000, 21000000, 24890000, 26000000, 26000000, 26000000, 26000000};
unsigned long frequency_1[13]={1810000, 3500000, 7000000, 10100000, 14000000, 18068000, 21000000, 24890000, 26000000, 26000000, 26000000, 26000000}; 


 // ++++    ++++
void initialization(void)

{
PORTB=0x00;
DDRB=0x3F;
PORTC=0x00;
DDRC=0x3E;
PORTD=0x00;
DDRD=0xF0;
MCUCR = (0<<PUD);

 // 
 
 //. ,   ,  ,  . = FCPU/128
   
DIDR0=0x00;
ADMUX = (0<<REFS1)|(1<<REFS0)|(0<<ADLAR)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0);
ADCSRA=(1<<ADEN)|(0<<ADSC)|(0<<ADATE)|(0<<ADIF)|(0<<ADIE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0); 
ADCSRB&=0xF8; 


// 

TCNT0 = TCNT0_const; //     
TCCR0B = TCCR0_const; //    =1024
TIMSK0 = (1<<TOIE0);  //    
}
  
ISR(TIMER0_OVF_vect)

{
  
  t=1; //    
}
 
 /*********************    *******/        
  void band (int z) 
{
 //int shift;

switch (z)
 {
case 0 : shift = 0b1000000000000000; break;
case 1 : shift = 0b0100000000000000; break;
case 2 : shift = 0b0010000000000000; break;
case 3 : shift = 0b0001000000000000; break;
case 4 : shift = 0b0000100000000000; break;
case 5 : shift = 0b0000010000000000; break;
case 6 : shift = 0b0000001000000000; break;
case 7 : shift = 0b0000000100000000; break;
case 8 : shift = 0b0000000010000001; break;
case 9 : shift = 0b0000000001000010; break;
case 10 :shift = 0b0000000000100100; break;
case 11 :shift = 0b0000000000011000; break;



 }

//void k595_init(char m)
 {

unsigned int i; 
unsigned int tmp;

tmp = shift;                        

for (i = 0; i < 12; i++)
 { 
if (tmp & 0x8000) 
PORTB |=_BV(PB3);  
else  PORTB &=~(_BV(PB3));
_delay_us(3);

PORTB |=_BV(PB5);                // 
_delay_us(3);

PORTB &=~(_BV(PB5)); 
tmp <<= 1;                       //    

   } 
   
} 

PORTD |=_BV(PD7);
          _delay_us(3); 
		     PORTD &=~(_BV(PD7));  //  

}

/*********************    *******/        
  void chagy (char z) 
{

switch (z)
 {
case 0 : chagi_1 = 10; break;
case 1 : chagi_1 = 100; break;
case 2 : chagi_1 = 500; break;
case 3 : chagi_1 = 1000; break;
case 4 : chagi_1 = 10000; break;

 }
 lcd_init(chagi_1); 
_delay_ms(1000);
lcd_init(frequency); 

}

/********************    **************/

void calk_freq()                   
             
{                

{ 
   //frequency =frequency_t; 
   frequency=frequency+chagi*bufEnc;
   
   if (frequency > (freq_max[(int)_band]))    frequency=(freq_min[(int)_band]);
    if (frequency < (freq_min[(int)_band]))    frequency=(freq_max[(int)_band]);
     frequency_1[(int)_band]=frequency;

}
   	  
}   

/*************************      *************************/
void Key_kontr()

{
ADMUX = (0<<REFS1)|(1<<REFS0)|(0<<ADLAR)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0);
 
    
  ADCSRA |= (1<<ADSC);                                        //  .
    while ((ADCSRA&(1 << ADIF))== 0);                         //    
   {
   }  
    
        AdcBuf = ADC;                                          //     
   	  
  if (AdcBuf<1000)                                              //    - 
 {
    n=1;
 
    }
 
    } 
 
/*******************    ******************/
void Key_1()
{
	band_2=_band;

	_delay_ms(5);  
	ADCSRA |= (1<<ADSC); 
	while ((ADCSRA&(1 << ADIF))== 0);           //   
	{
	}
    
	AdcBuf = ADC;                                //     
    
	Adc_1=ADC;  
	Key_2();
  

	
	if      (Adc_1 < 250)  l=7;	                         //Band UP
	else if (Adc_1 < 350)   l=6;                         //Band down
	else if (Adc_1 < 450)    l=5;                        //Step Up  
	else if (Adc_1 < 550)     l=4;                       //Step down
	else if (Adc_1 < 650)      l=3;                      //Lock_val
   
	else l=8;	

	if (l==7)
	{ 
		_band=_band+1;
		if  (_band>11)   
			_band=0; 
	} 
  
	if (l==6)
	{
		_band=_band-1;
		if  (_band==0xFFFF)   
			_band=11;
	}  
 
	if (l==5)
	{ 
		fast =fast+1;
		if  (fast>4)   
			fast=0; 
		chagy (fast);
	}

	if (l==4)

	{
		fast =fast-1;
		if  (fast<0)   
			fast=4;
		chagy (fast);
	}
	if (fast==0) chagi=10;
	if (fast==1) chagi=100;
	if (fast==2) chagi=500;
	if (fast==3) chagi=1000;
	if (fast==4) chagi=10000;

	if (l==3)
	{
		y=y+1;

		if (y==2)
		   y=0;
		if (y==1)
			PORTD |=_BV(PD6);
		else
			PORTD &=~(_BV(PD6));
	}

	if (band_2!=_band) 
	{ 
  
		band(_band);
    
		frequency = frequency_1[(int)_band];
		calk_freq();
		lcd_init(frequency);
        ad9850SetFrequency(frequency, _band);
	}	  
	if (_band>3)
	    PORTC |=_BV(PC3);
    else  
	    PORTC &=~_BV(PC3);
}
 
 /***********************    ************************/
 void Key_2()
 {
 do
 {
  ADCSRA |= (1<<ADSC);                                       //  .
   while ((ADCSRA&(1 << ADIF))== 0);           //   
   {
   }
    
    AdcBuf = ADC;                               //              
      
	
 } 
  while (AdcBuf<1000);                                    //   - 
 } 



void initialization_1(void)

{
  PORTC &=~(_BV(PC2)); 
   PORTB &=~(_BV(PB4));
    _delay_us(1);
	  PORTC |=_BV(PC2);
	   _delay_us(1);
	    PORTC &=~(_BV(PC2)); 
		 _delay_us(1); 
		  PORTB |=_BV(PB4);
		  	 _delay_us(1);  
			  PORTB &=~(_BV(PB4));  
}

void send_byte(char byte)

{
   int i;
    

    tmp = byte;                  

       for (i = 0; i < 8; i++)	 
{
       if (tmp & 0x01)
	              
	         send_1;            
          
             else   
			 send_0;


_delay_us(1);

       PORTC |=_BV(PC2);                // 
_delay_us(1);

       PORTC &=~(_BV(PC2)); 

       tmp >>= 1;                     // Get next bit in bit15      
}
}
/***********************  AD9850 ************************/

void ad9850SetFrequency(unsigned long y_1, int _band)

 {
 //if (_band<4) y_1=y_1+pch;
 // else y_1 = y_1-pch;
 y_1 = y_1+pch;
  
 freq = y_1 * 4294967296 / F_MCLK;

  send_byte  (freq & 0x000000FF);
   send_byte  ((freq & 0x0000FF00)>>8);
    send_byte  ((freq & 0x00FF0000)>>16);
	 send_byte  ((freq & 0xFF000000)>>24);
	  send_byte  (0b00000000);
  
 
  PORTB |=_BV(PB4);                // 

  _delay_us(1);

   PORTB &=~(_BV(PB4)); 
   _delay_us(1);
   
}
  
/************    *******************/                
int main(void)
{
_delay_ms(100);
initialization();
 initialization_1();
  
   _band=2;
     band(_band);   
	        
      frequency = (frequency_1 [(int)_band]);
       lcd_init(frequency);
	     ad9850SetFrequency(frequency, _band); 
		   TCNT0 =  TCNT0_const;        // 
             
while (1)                               // 
{
if (y==0) PollEncoder(); 
//PollEncoder(); 
  

 if (bufEnc!=0)
  { 
    
     calk_freq();                            
      bufEnc=0;                             //                         
       lcd_init(frequency);
	    _delay_us(10);
         ad9850SetFrequency(frequency, _band); 
  }  
   
Key_kontr();
 
if (n==1)
 {
Key_1();
    n=0;

 }
   
 t=0;
TCNT0 =  TCNT0_const;                  //  
 

  }

  }

